#####################################################################################
#
#	:::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]:::
#				 ___                 _
#				| __| __ _  __ _  __| | _ _  ___  _ __
#				| _| / _` |/ _` |/ _` || '_|/ _ \| '_ \
#				|___|\__, |\__, |\__,_||_|  \___/| .__/
#				     |___/ |___/                 |_|
#
#####################################################################################
# zip.tcl v1.0
# :
#	     .
# 
# : 1)   zip.tcl   scripts;
#			 2)      data;
#			 3)  eggdrop.conf  source scripts/zip.tcl
#
# .chanset #channel [+|-]zipcode - | 
#####################################################################################
#
#	30.03.2008
#	v1.01 edit by adium
#	-     +/-usecolors;
#	-     ;
#	-    ;
#
#####
#
#	30.03.2008
#	v1.0 edit by adium
#	-  .
#
#####################################################################################

namespace eval zipcode {
	variable author			{adium@RusNet}
	variable version		{1.0}
	variable date			{30-MAR-2008}
	variable unamespace		[string range [namespace current] 2 end]
	variable chflag			$unamespace
	variable pause			{60}
	
	setudef flag			$chflag
	
	if {![info exists egglib(ver)]} {
		setudef flag			usecolors
	}

	variable prefix			{!}
	variable flags			{-|-}

	variable binds			{zip zipcode   }

	variable datafile_ru	{data/zip_ru.dat}
	variable datafile_ua	{data/zip_ua.dat}

	foreach b [split $binds " "] {
		bind pub -|- "${prefix}${b}" ::zipcode::main
	}

	proc main {nick uhost hand chan text} {
		variable chflag
		if {![channel get $chan $chflag]} { return 0 }
		set text [string range [join $text] 0 end]
		putlog "$text"
		if {[string is space $text]} {
			variable prefix
			putserv "NOTICE $nick :\00314 \00304${prefix}zipcode\00314 <\00304\00314>  \00304${prefix}zipcode\00314 <\00304\00314>\003"
			return 0
		}
		
		variable pause
		variable lastcall
		if {[info exists lastcall($uhost)]} {
			if {[expr [expr [unixtime] - $lastcall($uhost)] < $pause]} {
				set det [expr [unixtime] - $lastcall($uhost)]
				set wtime [expr $pause - $det]
				variable prefix
				putserv "NOTICE $nick :\00314    \00304${prefix}zipcode\00314  \00310[timereplace $wtime]\003"
				return 0
			}
		}
		set lastcall($uhost) [unixtime]
		putlog "[regexp -- {^\d+$} $text] && ![regexp -nocase -- {[a-z-]} $text]"
		if {[regexp -- {^\d+$} $text]} {
			variable datafile_ru
			set file [open "$datafile_ru" r]
			while {[gets $file line] >= "0"} {
				set line [split [string trim $line] |]
				if {[lindex $line 2] == $text} {
					if {[channel get $chan usecolors]} {
						putserv "PRIVMSG $chan :\00303:\00314 \00307; \00303: \00314[lindex $line 0]\00307; \00303: \00314[lindex $line 1]\00307; \00303 : \00314[lindex $line 2]\003"
					} else {
						putserv "PRIVMSG $chan :: ; : [lindex $line 0]; : [lindex $line 1];  : [lindex $line 2]"
					}
					close $file
					return 0
				}
			}
			variable datafile_ua
			set file [open "$datafile_ua" r]
			while {[gets $file line] >= "0"} {
				set line [split [string trim $line] |]
				if {[lindex $line 2] == $text} {
					if {[channel get $chan usecolors]} {
						putserv "PRIVMSG $chan :\00303:\00314 \00307; \00303: \00314[lindex $line 0]\00307; \00303: \00314[lindex $line 1]\00307; \00303 : \00314[lindex $line 2]\003"
					} else {
						putserv "PRIVMSG $chan :: ; : [lindex $line 0]; : [lindex $line 1];  : [lindex $line 2]"
					}
					close $file
					return 0
				}
			}
		} elseif {[regexp -nocase -- {[a-z-]} $text]} {
			if {[expr [string length $text] < 4]} {
				putserv "NOTICE $nick :\00314   .\003"
				return 0
			}
			variable datafile_ru
			set file [open "$datafile_ru" r]
			while {[gets $file line] >= "0"} {
				set line [split [string trim $line] |]
				if {[string match *[string tolower $text]* [string tolower [lindex $line 0]]]} {
					if {[channel get $chan usecolors]} {
						putserv "PRIVMSG $chan :\00303:\00314 \00307; \00303: \00314[lindex $line 0]\00307; \00303: \00314[lindex $line 1]\00307; \00303 : \00314[lindex $line 2]\003"
					} else {
						putserv "PRIVMSG $chan :: ; : [lindex $line 0]; : [lindex $line 1];  : [lindex $line 2]"
					}
					close $file
					return 0
				}
			}
			variable datafile_ua
			set file [open "$datafile_ua" r]
			while {[gets $file line] >= "0"} {
				set line [split [string trim $line] |]
				if {[string match *[string tolower $text]* [string tolower [lindex $line 0]]]} {
					if {[channel get $chan usecolors]} {
						putserv "PRIVMSG $chan :\00303:\00314 \00307; \00303: \00314[lindex $line 0]\00307; \00303: \00314[lindex $line 1]\00307; \00303 : \00314[lindex $line 2]\003"
					} else {
						putserv "PRIVMSG $chan :: ; : [lindex $line 0]; : [lindex $line 1];  : [lindex $line 2]"
					}
					close $file
					return 0
				}
			}
		} else {
			if {[channel get $chan usecolors]} {
				putserv "PRIVMSG $chan :\00303$nick\00314,   \00303\'$text\' \00314   .\003"
			} else {
				putserv "PRIVMSG $chan :$nick,   \'$text\'   ."
			}
			close $file
		}
	}
	
	proc timereplace {text} {
		set text [duration $text]
		set t [lindex $text end-1]
		set m [lindex $text end-3]
		set ti 0
		set mi 0

		if {$t == "0" || $t == "11" || $t == "12" || $t == "13" || $t == "14"} {
			regsub -all -- {seconds} $text {} text
			set ti 1
		} elseif {$t == "1"} {
			regsub -all -- {second} $text {} text
			set ti 1
		} elseif {$t == "2" || $t == "3" || $t == "4"} {
			regsub -all -- {seconds} $text {} text
			set ti 1
		} elseif {$t >= 5 && !$ti} {
			switch -- [string index $t end] { 
				0 { regsub -all -- {seconds} $text {} text }
				1 { regsub -all -- {seconds} $text {} text }
				2 - 3 - 4 { regsub -all -- {seconds} $text {} text }
				default { regsub -all -- {seconds} $text {} text }
			}
		}
		if {$m == "0" || $m == "11" || $m == "12" || $m == "13" || $m == "14"} {
			regsub	-all	--	{minutes}	$text	{}		text
			set mi 1
		} elseif {$m == "1"} {
			regsub	-all	--	{minute}	$text	{}	text
			set mi 1
		} elseif {$m == "2" || $m == "3" || $m == "4"} {
			regsub	-all	--	{minutes}	$text	{}	text
			set mi 1
		} elseif {$m >= 5 && !$mi} {
			switch -- [string index $m end] {
				0 { regsub -all -- {minutes} $text {} text }
				1 { regsub -all -- {minutes} $text {} text }
				2 - 3 - 4 { regsub -all -- {minutes} $text {} text }
				default { regsub -all -- {minutes} $text {} text }
			}
		}
		return $text
	}

	putlog "[namespace current]:: v$version \[$date\] by $author loaded."
}